#include "atmega328.h"

	.device ATmega328P
	.org 0x00
	rjmp reset

	.org 0x1c
	rjmp timer0_compa

	.org 0x34
reset:
	ldi r16, high(RAMEND)
	out SPH, r16
	ldi r17, low(RAMEND)
	out SPL, r16

	rcall setup_jiffies
	sei

	ldi r18, bit(5)
	clr r20
	out DDRB, r18
	ldi r16, 0xf4
	ldi r17, 0x01
loop:
	rcall delay_ms
	eor r20, r18
	out PORTB, r20
	rjmp loop


setup_jiffies:
	push r16

	clr r16
	sts JIFFIES, r16
	sts JIFFIES + 1, r16
	sts JIFFIES + 2, r16
	sts JIFFIES + 3, r16

	sts iospace(TCNT0), r16
	ldi r16, bit(WGM01)
	sts iospace(TCCR0A), r16
	ldi r16, (bit(CS00) | bit(CS01))
	sts iospace(TCCR0B), r16
	ldi r16, 0xf9
	sts iospace(OCR0A), r16
	ldi r16, bit(OCIE0A)
	sts iospace(TIMSK0), r16

	pop r16
	ret


timer0_compa:
	push r24
	push r25
	push r26
	push r27
	push r16
	push r18
	in r18, SREG

	lds r24, JIFFIES
	lds r25, JIFFIES + 1
	lds r26, JIFFIES + 2
	lds r27, JIFFIES + 3

	clr r16
	adiw r24, 0x0001
	adc r26, r16
	adc r27, r16

	sts JIFFIES, r24
	sts JIFFIES + 1, r25
	sts JIFFIES + 2, r26
	sts JIFFIES + 3, r27

	out SREG, r18
	pop r18
	pop r16
	pop r27
	pop r26
	pop r25
	pop r24
	reti


delay_ms:
	tst r16
	brne start_delay
	tst r17
	brne start_delay
	ret

start_delay:
	push r16
	push r17
	push r18
	push r24
	push r25
	push r26
	push r27
	push r28
	push r29
	push r30
	push r31

	cli
	lds r24, JIFFIES
	lds r25, JIFFIES + 1
	lds r26, JIFFIES + 2
	lds r27, JIFFIES + 3
	sei

	clr r18
	add r24, r16
	adc r25, r17
	adc r26, r18
	adc r27, r18

test_again:
	lds r31, JIFFIES + 3
	lds r30, JIFFIES + 2
	lds r29, JIFFIES + 1
	lds r28, JIFFIES

	cp r28, r24
	brne test_again
	cp r29, r25
	brne test_again
	cp r30, r26
	brne test_again
	cp r31, r27
	brne test_again

	pop r31
	pop r30
	pop r29
	pop r28
	pop r27
	pop r26
	pop r25
	pop r24
	pop r18
	pop r17
	pop r16
	ret
