#include "atmega328.h"

	.device ATmega328P
	.org 0x00
	rjmp reset

	.org 0x24
	rjmp uart_rx_complete

	.org 0x34
reset:
	ldi r16, high(RAMEND)
	out SPH, r16
	ldi r17, low(RAMEND)
	out SPL, r16

	ldi r16, 63
	out DDRB, r16

	rcall setup_uart
	sei
loop:
	rjmp loop


setup_uart:
	ldi r16, low(207)
	sts iospace(UBRR0L), r16
	ldi r16, high(207)
	sts iospace(UBRR0H), r16

	ldi r16, bit(U2X0)
	sts iospace(UCSR0A), r16

	ldi r16, (bit(UCSZ00) | bit(UCSZ01))
	sts iospace(UCSR0C), r16

	ldi r16, (bit(RXEN0) | bit(RXCIE0))
	sts iospace(UCSR0B), r16
	ret


uart_rx_complete:
	push r16
	lds r16, iospace(UDR0)
	out PORTB, r16
	pop r16
	reti
